#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include "fontgen.h"
void version(void){

  printf(
"Application: %s, Version %s\n"
"Date: %s\n"
"Host: %s\n",
BUILD_APPLICATION,
BUILD_VERSION,
BUILD_DATE,
BUILD_HOST
);
}

#define PROCESS(name) { close(1); open("font_" #name ".asm",O_WRONLY+O_TRUNC+O_CREAT,0644); }
#define OP_FONT(name,base,top) {name.f_base=base; name.f_top=top;name.f_offset=((top-base)*7)/4; op_font(&name);}
int main(int argc, char** argv){

  font_init();
  int i;
  for (i=0;i<51;i++){
    
    switch(i){
    case 0:
      PROCESS(cyrilc);
      OP_FONT(font_cyrilc,-9,12);
      break;
    case 1: 
      PROCESS(gothgbt); 
      OP_FONT(font_gothgbt,-9,12); 
      break; 
    case 2: 
      PROCESS(gothgrt); 
      OP_FONT(font_gothgrt,-9,12); 
      break; 
    case 3: 
      PROCESS(gothitt); 
      OP_FONT(font_gothitt,-9,12); 
      break; 
    case 4: 
      PROCESS(greekc); 
      OP_FONT(font_greekc,-9,12); 
      break; 
    case 5: 
      PROCESS(greekcs); 
      OP_FONT(font_greekcs,-6,7); 
      break; 
    case 6: 
      PROCESS(greekp); 
      OP_FONT(font_greekp,-5,4); 
      break; 
    case 7: 
      PROCESS(greeks); 
      OP_FONT(font_greeks,-9,12); 
      break; 
    case 8: 
      PROCESS(italicc); 
      OP_FONT(font_italicc,-9,12); 
      break; 
    case 9: 
      PROCESS(italiccs); 
      OP_FONT(font_italiccs,-6,7); 
      break; 
    case 10: 
      PROCESS(italict); 
      OP_FONT(font_italict,-9,12); 
      break; 
    case 11: 
      PROCESS(romanc); 
      OP_FONT(font_romanc,-9,12); 
      break; 
    case 12: 
      PROCESS(romancs); 
      OP_FONT(font_romancs,-6,7); 
      break; 
    case 13: 
      PROCESS(romand); 
      OP_FONT(font_romand,-9,12); 
      break; 
    case 14: 
      PROCESS(romanp); 
      OP_FONT(font_romanp,-5,4); 
      break; 
    case 15: 
      PROCESS(romans); 
      OP_FONT(font_romans,-9,12); 
      break; 
    case 16: 
      PROCESS(romant); 
      OP_FONT(font_romant,-9,12); 
      break; 
    case 17: 
      PROCESS(scriptc); 
      OP_FONT(font_scriptc,-9,12); 
      break; 
    case 18: 
      PROCESS(scripts); 
      OP_FONT(font_scripts,-9,12); 
      break; 

    case 19: PROCESS(astrology); OP_FONT(font_astrology,-9,12);break;
    case 20: PROCESS(cursive); OP_FONT(font_cursive,-9,12);break;
//    case 21: PROCESS(cyrilc_1); OP_FONT(font_cyrilc_1);break;
//    case 22: PROCESS(cyrillic); OP_FONT(font_cyrillic,-9,12);break;
    case 23: PROCESS(futural); OP_FONT(font_futural,-9,12);break;
    case 24: PROCESS(futuram); OP_FONT(font_futuram,-9,12);break;
    case 25: PROCESS(gothgbt); OP_FONT(font_gothgbt,-9,12);break;
    case 26: PROCESS(gothgrt); OP_FONT(font_gothgrt,-9,12);break;
      //    case 27: PROCESS(gothiceng); OP_FONT(font_gothiceng,-9,12);break;
      //    case 28: PROCESS(gothicger); OP_FONT(font_gothicger,-9,12);break;
    case 29: PROCESS(gothicita); OP_FONT(font_gothicita,-9,12);break;
      //    case 30: PROCESS(gothitt); OP_FONT(font_gothitt,-9,12);break;
//    case 31: PROCESS(greekc); OP_FONT(font_greekc,-9,12);break;
//    case 32: PROCESS(greek); OP_FONT(font_greek,-9,12);break;
//    case 33: PROCESS(greeks); OP_FONT(font_greeks,-9,12);break;
//    case 34: PROCESS(japanese); OP_FONT(font_japanese,-9,12);break;
    case 35: PROCESS(markers); OP_FONT(font_markers,-9,12);break;
    case 36: PROCESS(mathlow); OP_FONT(font_mathlow,-9,12);break;
    case 37: PROCESS(mathupp); OP_FONT(font_mathupp,-5,4);break;
    case 38: PROCESS(meteorology); OP_FONT(font_meteorology,-9,12);break;
    case 39: PROCESS(music); OP_FONT(font_music,-9,12);break;
    case 40: PROCESS(rowmand); OP_FONT(font_rowmand,-9,12);break;
    case 41: PROCESS(rowmans); OP_FONT(font_rowmans,-9,12);break;
    case 42: PROCESS(rowmant); OP_FONT(font_rowmant,-9,12);break;
      // case 43: PROCESS(scriptc_1); OP_FONT(font_scriptc,-9,12);break;
      // case 44: PROCESS(scripts_1); OP_FONT(font_scripts,-9,12);break;
    case 45: PROCESS(symbolic); OP_FONT(font_symbolic,-9,12);break;
    case 46: PROCESS(timesg); OP_FONT(font_timesg,-9,12);break;
    case 47: PROCESS(timesib); OP_FONT(font_timesib,-9,12);break;
    case 48: PROCESS(timesi); OP_FONT(font_timesi,-9,12);break;
    case 49: PROCESS(timesrb); OP_FONT(font_timesrb,-9,12);break;
    case 50: PROCESS(timesr); OP_FONT(font_timesr,-9,12);break;

      

    }
  }

  pl_font f;

  PROCESS(hp_charset0_2);
  f=hp_convert(charset0 ,2);
  op_font(&f);

  PROCESS(hp_charset1_2);
  f=hp_convert(charset1 ,2);
  op_font(&f);

  PROCESS(hp_charset2_2);
  f=hp_convert(charset2 ,2);
  op_font(&f);
  
  PROCESS(hp_charset3_2);
  f=hp_convert(charset3 ,2);
  op_font(&f);

  PROCESS(hp_charset4_2);
  f=hp_convert(charset4 ,2);
  op_font(&f);

  PROCESS(hp_charset5_2);
  f=hp_convert(charset5 ,2);
  op_font(&f);

  PROCESS(hp_charset6_2);
  f=hp_convert(charset6 ,2);
  op_font(&f);

  PROCESS(hp_charset7_2);
  f=hp_convert(charset7 ,2);
  op_font(&f);

  PROCESS(hp_charset173_2);
  f=hp_convert(charset173,2);
  op_font(&f);

  PROCESS(hp_charset205_2);
  f=hp_convert(charset205 ,2);
  op_font(&f);

  PROCESS(hp_charset0_3);
  f=hp_convert(charset0 ,3);
  op_font(&f);

  PROCESS(hp_charset1_3);
    f=hp_convert(charset1 ,3);
  op_font(&f);

  PROCESS(hp_charset2_3);
  f=hp_convert(charset2 ,3);
  op_font(&f);

  PROCESS(hp_charset3_3);
  f=hp_convert(charset3 ,3);
  op_font(&f);

  PROCESS(hp_charset4_3);
  f=hp_convert(charset4 ,3);
  op_font(&f);

  PROCESS(hp_charset5_3);
  f=hp_convert(charset5 ,3);
  op_font(&f);

  PROCESS(hp_charset6_3);
  f=hp_convert(charset6 ,3);
  op_font(&f);

  PROCESS(hp_charset7_3);
  f=hp_convert(charset7 ,3);
  op_font(&f);

  PROCESS(hp_charset173_3);
  f=hp_convert(charset173,3);
  op_font(&f);

  PROCESS(hp_charset205_3);
  f=hp_convert(charset205 ,3);
  op_font(&f);

  PROCESS(hp_charset0_4);
  f=hp_convert(charset0 ,4);
  op_font(&f);

  PROCESS(hp_charset1_4);
    f=hp_convert(charset1 ,4);
  op_font(&f);

  PROCESS(hp_charset2_4);
  f=hp_convert(charset2 ,4);
  op_font(&f);

  PROCESS(hp_charset3_4);
  f=hp_convert(charset3 ,4);
  op_font(&f);

  PROCESS(hp_charset4_4);
  f=hp_convert(charset4 ,4);
  op_font(&f);

  PROCESS(hp_charset5_4);
  f=hp_convert(charset5 ,4);
  op_font(&f);

  PROCESS(hp_charset6_4);
  f=hp_convert(charset6 ,4);
  op_font(&f);

  PROCESS(hp_charset7_4);
  f=hp_convert(charset7 ,4);
  op_font(&f);

  PROCESS(hp_charset173_4);
  f=hp_convert(charset173,4);
  op_font(&f);

  PROCESS(hp_charset205_4);
  f=hp_convert(charset205 ,4);
  op_font(&f);


  PROCESS(hp_charset0_1);
  f=hp_convert(charset0 ,1);
  op_font(&f);

  PROCESS(hp_charset1_1);
  f=hp_convert(charset1 ,1);
  op_font(&f);

  PROCESS(hp_charset2_1);
  f=hp_convert(charset2 ,1);
  op_font(&f);

  PROCESS(hp_charset3_1);
  f=hp_convert(charset3 ,1);
  op_font(&f);

  PROCESS(hp_charset4_1);
  f=hp_convert(charset4 ,1);
  op_font(&f);

  PROCESS(hp_charset5_1);
  f=hp_convert(charset5 ,1);
  op_font(&f);

  PROCESS(hp_charset6_1);
  f=hp_convert(charset6 ,1);
  op_font(&f);

  PROCESS(hp_charset7_1);
  f=hp_convert(charset7 ,1);
  op_font(&f);

  PROCESS(hp_charset173_1);
  f=hp_convert(charset173,1);
  op_font(&f);

  PROCESS(hp_charset205_1);
  f=hp_convert(charset205 ,1);
  op_font(&f);

  exit(0);
}
